$servers = @("WAP01.contoso.com","DB01.contoso.com","DB02.contoso.com","DB03.contoso.com","DB04.contoso.com","DB05.contoso.com","OM01.contoso.com","OR01.contoso.com",
"SM01.contoso.com","SM02.contoso.com","SM03.contoso.com","VMM01.contoso.com","FS01.contoso.com")

$IncludeRecommended = $true
$bolUseMicrosoftUpdate = $true 
$bolEnableAutoUpdates = $true

$MicrosoftUpdateltiRebootScriptPath = "c:\scripts\"
$MicrosoftUpdateltiRebootScriptName = "Updates.ps1"
$UseWSUS = $false 
$bolMultiBoot = $true 


$servers = $servers | sort-object
Import-Module D:\temp\PSWindowsUpdate\PSWindowsUpdate\PSWindowsUpdate.psd1

foreach ($computername in $servers){
    $computername
    $Script = ""
    
    if ($bolUseMicrosoftUpdate -eq $true ){
        Write-Host "Enabling Microsoft Update service"
        Invoke-Command -ComputerName $computername -ScriptBlock {
            $MicrosoftUpdate = New-Object -ComObject Microsoft.Update.ServiceManager -Strict 
            $MicrosoftUpdate.AddService2("7971f918-a847-4430-9279-4a52d1efe18d",7,"")
        }
    }
    if ($bolMultiBoot -eq $true){
        $RemoteMultiRebootScriptPath = ""
        # Remove the drive letter 
        $RemoteMultiRebootScriptPath = $MicrosoftUpdateltiRebootScriptPath.Substring(3)
        $RemoteMultiRebootScriptDriveLetter = $MicrosoftUpdateltiRebootScriptPath.Substring(0,1)
        # Add in server name
        $RemoteMultiRebootScriptPath = "\\$computername\$RemoteMultiRebootScriptDriveLetter`$\$RemoteMultiRebootScriptPath"
        if (!(test-path "$remoteMultiRebootScriptPath")){
            Write-host "Create folder"
            New-Item -ItemType Directory -Path $RemoteMultiRebootScriptPath | Out-Null
        } else {
            Write-host "Remote Folder Exists"
        }
        if (!(test-path "$remoteMultiRebootScriptPath\$MicrosoftUpdateltiRebootScriptName")){
$FileContents = @"
Param(
    [String]`$MicrosoftUpdateltiBootLogFile = "C:\PSWindowsUpdateMultiBoot.log",
    [string]`$TaskName = "PSWindowsUpdate",
    [bool]`$UseWSUS = `$False,
    [int]`$MaxBoots = 5
    )

write-host "Enabling Update across reboots"
# register the task to run at first boot.

write-host "Enabling Update across reboots"
[string]`$MicrosoftUpdateltiBootReg = "HKLM:\software\PSWindowsUpdate"

`$Scheduler = New-Object -ComObject Schedule.Service
`$Scheduler.Connect("localhost")
`$rootFolder = `$Scheduler.getfolder("\")
`$ScheduledTask = `$rootFolder.GetTasks(0) | where {`$_.name -eq `$TaskName}
if (`$ScheduledTask -ne `$null){
    `$TaskDefinition = `$ScheduledTask.Definition
    `$triggers = @(`$TaskDefinition.Triggers)
    if (`$triggers.count -eq 0){
        Write-host "Add boot Trigger"
        if (!(test-path `$MicrosoftUpdateltiBootReg) ) {New-Item -Path `$MicrosoftUpdateltiBootReg | out-null; Write-host "Create boot reg key"}
        Set-ItemProperty -Path `$MicrosoftUpdateltiBootReg -name "BootNumber" -Value "0" -Force  -Type DWord
        `$trigger = `$TaskDefinition.Triggers.Create(8)
        `$trigger.Enabled = `$True
        `$trigger.Delay = "PT5M"
        `$Rootfolder.RegisterTaskDefinition(`$Scheduledtask.Name, `$Taskdefinition, 4, `$null, `$null, `$null) | out-null
    } else {
        if (!(test-path `$MicrosoftUpdateltiBootReg) ) {
            New-Item -Path `$MicrosoftUpdateltiBootReg
            `$BootNumber = 0 
        } else {
            `$BootNumber = [int](Get-ItemProperty -Path `$MicrosoftUpdateltiBootReg -Name "BootNumber").bootnumber
        }
        if (`$bootNumber -le `$MaxBoots){
            write-host "Current Boot number `$BootNumber"
            `$nextBoot = `$BootNumber+1
            Write-host "Next Boot number `$nextboot"
            Set-ItemProperty -Path `$MicrosoftUpdateltiBootReg -name "BootNumber" -Value `$nextBoot -Force -Type DWord
        } Else {
            Write-host "Max number of boots reached.  Exiting"
        }
    }

    # If Running Windows Update VS Microsoft update then add in the correct update settings
    `$numberofUpdates = 0
    write-host "Checkingfor list updates needed"
    ipmo PSWindowsUpdate;
    if (`$UseWSUS -eq `$True){
        `$numberOfUpdates = @(get-wulist -WindowsUpdate)
    } else {
        `$numberOfUpdates = @(get-wulist -MicrosoftUpdate)
    }

    write-host "Number of updates needed: "`$numberofUpdates.count
    `$numberofUpdates.count | Out-File C:\NumberOfUpdates.log
    If ((`$numberofUpdates.count -eq 0 ) -or (`$bootNumber -ge `$MaxBoots)){
        Write-host "Remove Remote Trigger"
        Remove-Item -Path `$MicrosoftUpdateltiBootReg -Recurse
        `$trigger = `$TaskDefinition.Triggers.Clear()
        `$Rootfolder.RegisterTaskDefinition(`$Scheduledtask.Name, `$Taskdefinition, 4, `$null, `$null, `$null) | out-null
    }
}
Else {
    Write-host "No task can be found"

}

"@
            $FileContents | out-file "$remoteMultiRebootScriptPath\$MicrosoftUpdateltiRebootScriptName" -Encoding unicode -Force
        } else {
            Write-host "Remote Script Exists"
        }

        $TempScriptBlock = ""
        $TempScriptBlock = "invoke-expression -Command `"$MicrosoftUpdateltiRebootScriptPath\$MicrosoftUpdateltiRebootScriptName`" "
        $script = $TempScriptBlock.ToString() + "`n" + $Script.ToString()
    }
    if ($IncludeRecommended -eq $true ){
        Write-Host "Enabling Recommended Updates"
        $TempScriptBlock = ""
        $TempScriptBlock = {
            $WindowsUpdateSettings = (New-Object -com "Microsoft.Update.AutoUpdate").Settings
            $WindowsUpdateSettings.IncludeRecommendedUpdates = $true
            $WindowsUpdateSettings.save()
            (New-Object -com "Microsoft.Update.AutoUpdate").Settings | Out-File C:\IncludeRecommended.log
        }
        $script = $TempScriptBlock.ToString() + "`n" + $Script.ToString()
    }
    if ($bolEnableAutoUpdates -eq $true ){
        Write-Host "Enabling AutoMatic Updates"
        # Following table gives values for setting notification level.
        # Disabling Automatic Updates: 0
        # Never Check for Updates: 1
        # Check for updates but let me choose whether to download and install them: 2
        # Download Updates and let me choose whether to install them : 3
        # Install Updates Automatically: 4

        $TempScriptBlock = ""
        $TempScriptBlock = {
            $WindowsUpdateSettings = (New-Object -com "Microsoft.Update.AutoUpdate").Settings
            $WindowsUpdateSettings.NotificationLevel = 4
            $WindowsUpdateSettings.save()
            (New-Object -com "Microsoft.Update.AutoUpdate").Settings | Out-File C:\EnableUpdate.log
        }
        $script = $TempScriptBlock.ToString() + "`n" + $Script.ToString()
    }

    if ($UseWSUS -eq $True){
        Write-host "Updating using WSUS if configured"

        $tempScriptBlock = ""
        $TempScriptBlock = {
            ipmo PSWindowsUpdate;
            Get-WUInstall -WindowsUpdate -AcceptAll -AutoReboot -verbose  | Out-File C:\PSWindowsUpdate.log
        }
        $script = [ScriptBlock]::Create($Script.ToString() + "`n" + $TempScriptBlock.ToString())
        Invoke-WUInstall -ComputerName $computername  -OnlineUpdate -Script $Script -Confirm:$false -Verbose
    }else{
        Write-host "Updating using Windows Update"
        $tempScriptBlock = ""
        $TempScriptBlock = {
            ipmo PSWindowsUpdate;
            Get-WUInstall -MicrosoftUpdate -AcceptAll -AutoReboot -verbose  | Out-File C:\PSWindowsUpdate.log
        }
        $script = [ScriptBlock]::Create($Script.ToString() + "`n" + $TempScriptBlock.ToString())
        Invoke-WUInstall -ComputerName $computername -OnlineUpdate -Script $Script -Confirm:$false -Verbose
    }
}